<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use \Doctrine\ORM\EntityManager;
use Teknisa\MAN\Services\ProdutividadeVendedor;


class ProdutividadeVendedorContinuo extends ProdutividadeVendedor{

	protected $entityManager;

	public function __construct(EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

    private function setReportParameters(&$params, &$conditions) {
        $params = array(
            ':DATAINI' => isset($conditions['DATAINI']) ? $conditions['DATAINI'] : null ,
            ':DATAFIN' => isset($conditions['DATAFIN']) ? $conditions['DATAFIN'] : null ,
            ':CDFILIAL' => isset($conditions['CDFILIAL']) ? $conditions['CDFILIAL'] : null ,
            ':TCDFILIAL' => isset($conditions['TCDFILIAL']) ? $conditions['TCDFILIAL'] : null ,
            ':CDLOJA' => isset($conditions['CDLOJA']) ? $conditions['CDLOJA'] : null ,
            ':TCDLOJA' => isset($conditions['TCDLOJA']) ? $conditions['TCDLOJA'] : null ,
            ':CDVENDEDOR' => isset($conditions['CDVENDEDOR']) ? $conditions['CDVENDEDOR'] : null ,
            ':TCDVENDEDOR' => isset($conditions['TCDVENDEDOR']) ? $conditions['TCDVENDEDOR'] : null ,
            ':DTMOVTURCAIX' => isset($conditions['DTMOVTURCAIX']) ? $conditions['DTMOVTURCAIX'] : null ,
            ':TDTMOVTURCAIX' => isset($conditions['TDTMOVTURCAIX']) ? $conditions['TDTMOVTURCAIX'] : null ,
            ':CDPRODUTO' => null,
            ':TCDPRODUTO' => 'T' 
        );
    }

    public function getProdutividadeVendedor($conditions) {
    	$params = [];
        $this->setReportParameters($params, $conditions);
        $query = "
            SELECT 
                TOTAL.CDFILIAL, 
			    TOTAL.NMFILIAL, 
			    TOTAL.CDLOJA, 
			    TOTAL.NMLOJA, 
                TOTAL.DTABERTUR,
                TOTAL.LABELFILIAL  AS FILILOJA,
            	TOTAL.NRINSJURVEN AS RAZAO,   
            	TOTAL.CDVENDEDOR||' - '||TOTAL.NMRAZSOCVEN AS NMRAZSOCVEN,
            	SUM(TOTAL.ACR) AS ACR,
                SUM(TOTAL.DES) AS DES,
                SUM(TOTAL.QTPRODVEND) AS QTDE,
                SUM(TOTAL.VRFINALITEM) AS VALOR_TOTAL,
                SUM(TOTAL.VRGORJETA) AS VRGORJETA,
                SUM(TOTAL.VRLIQUIDO) AS VRLIQUIDO,
                SUM(TOTAL.VRREPIQUEVENDA) AS VRREPIQUEVENDA,
                SUM(TOTAL.VRREPITEM) AS VRREPIQUE,
                SUM(TOTAL.VRTXENTREGA) AS VRTXENTREGA
            FROM( 
                 /*
				  Tabela PrincipalTotal 
				 */
				 ".$this->getQueryPrincipalTOTAL()."
			)TOTAL
			GROUP BY 
			    TOTAL.CDFILIAL, 
			    TOTAL.NMFILIAL, 
			    TOTAL.CDLOJA, 
			    TOTAL.NMLOJA, 
			    TOTAL.CDVENDEDOR,
                TOTAL.NMRAZSOCVEN, 
                TOTAL.DTABERTUR,
                TOTAL.LABELFILIAL,
                TOTAL.NRINSJURVEN
            ORDER BY 
                TOTAL.LABELFILIAL,
                TOTAL.DTABERTUR,
                TOTAL.CDVENDEDOR,
                TOTAL.NMRAZSOCVEN
        ";
        
        $query =  strval(trim($query));
        $qryPrincipal = $this->entityManager->getConnection()->fetchAll($query, $params);
        return $qryPrincipal;
    }
}